Imported Upstream version 2.9.0
[platform/upstream/git.git] / git-submodule.sh
1 #!/bin/sh
2 #
3 # git-submodule.sh: add, init, update or list git submodules
4 #
5 # Copyright (c) 2007 Lars Hjemli
6
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
9    or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10    or: $dashless [--quiet] init [--] [<path>...]
11    or: $dashless [--quiet] deinit [-f|--force] (--all| [--] <path>...)
12    or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--reference <repository>] [--recursive] [--] [<path>...]
13    or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
14    or: $dashless [--quiet] foreach [--recursive] <command>
15    or: $dashless [--quiet] sync [--recursive] [--] [<path>...]"
16 OPTIONS_SPEC=
17 SUBDIRECTORY_OK=Yes
18 . git-sh-setup
19 . git-sh-i18n
20 . git-parse-remote
21 require_work_tree
22 wt_prefix=$(git rev-parse --show-prefix)
23 cd_to_toplevel
24
25 # Restrict ourselves to a vanilla subset of protocols; the URLs
26 # we get are under control of a remote repository, and we do not
27 # want them kicking off arbitrary git-remote-* programs.
28 #
29 # If the user has already specified a set of allowed protocols,
30 # we assume they know what they're doing and use that instead.
31 : ${GIT_ALLOW_PROTOCOL=file:git:http:https:ssh}
32 export GIT_ALLOW_PROTOCOL
33
34 command=
35 branch=
36 force=
37 reference=
38 cached=
39 recursive=
40 init=
41 files=
42 remote=
43 nofetch=
44 update=
45 prefix=
46 custom_name=
47 depth=
48
49 die_if_unmatched ()
50 {
51         if test "$1" = "#unmatched"
52         then
53                 exit 1
54         fi
55 }
56
57 #
58 # Print a submodule configuration setting
59 #
60 # $1 = submodule name
61 # $2 = option name
62 # $3 = default value
63 #
64 # Checks in the usual git-config places first (for overrides),
65 # otherwise it falls back on .gitmodules.  This allows you to
66 # distribute project-wide defaults in .gitmodules, while still
67 # customizing individual repositories if necessary.  If the option is
68 # not in .gitmodules either, print a default value.
69 #
70 get_submodule_config () {
71         name="$1"
72         option="$2"
73         default="$3"
74         value=$(git config submodule."$name"."$option")
75         if test -z "$value"
76         then
77                 value=$(git config -f .gitmodules submodule."$name"."$option")
78         fi
79         printf '%s' "${value:-$default}"
80 }
81
82 isnumber()
83 {
84         n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
85 }
86
87 # Sanitize the local git environment for use within a submodule. We
88 # can't simply use clear_local_git_env since we want to preserve some
89 # of the settings from GIT_CONFIG_PARAMETERS.
90 sanitize_submodule_env()
91 {
92         save_config=$GIT_CONFIG_PARAMETERS
93         clear_local_git_env
94         GIT_CONFIG_PARAMETERS=$save_config
95         export GIT_CONFIG_PARAMETERS
96 }
97
98 #
99 # Add a new submodule to the working tree, .gitmodules and the index
100 #
101 # $@ = repo path
102 #
103 # optional branch is stored in global branch variable
104 #
105 cmd_add()
106 {
107         # parse $args after "submodule ... add".
108         reference_path=
109         while test $# -ne 0
110         do
111                 case "$1" in
112                 -b | --branch)
113                         case "$2" in '') usage ;; esac
114                         branch=$2
115                         shift
116                         ;;
117                 -f | --force)
118                         force=$1
119                         ;;
120                 -q|--quiet)
121                         GIT_QUIET=1
122                         ;;
123                 --reference)
124                         case "$2" in '') usage ;; esac
125                         reference_path=$2
126                         shift
127                         ;;
128                 --reference=*)
129                         reference_path="${1#--reference=}"
130                         ;;
131                 --name)
132                         case "$2" in '') usage ;; esac
133                         custom_name=$2
134                         shift
135                         ;;
136                 --depth)
137                         case "$2" in '') usage ;; esac
138                         depth="--depth=$2"
139                         shift
140                         ;;
141                 --depth=*)
142                         depth=$1
143                         ;;
144                 --)
145                         shift
146                         break
147                         ;;
148                 -*)
149                         usage
150                         ;;
151                 *)
152                         break
153                         ;;
154                 esac
155                 shift
156         done
157
158         if test -n "$reference_path"
159         then
160                 is_absolute_path "$reference_path" ||
161                 reference_path="$wt_prefix$reference_path"
162
163                 reference="--reference=$reference_path"
164         fi
165
166         repo=$1
167         sm_path=$2
168
169         if test -z "$sm_path"; then
170                 sm_path=$(printf '%s\n' "$repo" |
171                         sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
172         fi
173
174         if test -z "$repo" || test -z "$sm_path"; then
175                 usage
176         fi
177
178         is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
179
180         # assure repo is absolute or relative to parent
181         case "$repo" in
182         ./*|../*)
183                 test -z "$wt_prefix" ||
184                 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
185
186                 # dereference source url relative to parent's url
187                 realrepo=$(git submodule--helper resolve-relative-url "$repo") || exit
188                 ;;
189         *:*|/*)
190                 # absolute url
191                 realrepo=$repo
192                 ;;
193         *)
194                 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
195         ;;
196         esac
197
198         # normalize path:
199         # multiple //; leading ./; /./; /../; trailing /
200         sm_path=$(printf '%s/\n' "$sm_path" |
201                 sed -e '
202                         s|//*|/|g
203                         s|^\(\./\)*||
204                         s|/\(\./\)*|/|g
205                         :start
206                         s|\([^/]*\)/\.\./||
207                         tstart
208                         s|/*$||
209                 ')
210         git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
211         die "$(eval_gettext "'\$sm_path' already exists in the index")"
212
213         if test -z "$force" && ! git add --dry-run --ignore-missing "$sm_path" > /dev/null 2>&1
214         then
215                 eval_gettextln "The following path is ignored by one of your .gitignore files:
216 \$sm_path
217 Use -f if you really want to add it." >&2
218                 exit 1
219         fi
220
221         if test -n "$custom_name"
222         then
223                 sm_name="$custom_name"
224         else
225                 sm_name="$sm_path"
226         fi
227
228         # perhaps the path exists and is already a git repo, else clone it
229         if test -e "$sm_path"
230         then
231                 if test -d "$sm_path"/.git || test -f "$sm_path"/.git
232                 then
233                         eval_gettextln "Adding existing repo at '\$sm_path' to the index"
234                 else
235                         die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
236                 fi
237
238         else
239                 if test -d ".git/modules/$sm_name"
240                 then
241                         if test -z "$force"
242                         then
243                                 echo >&2 "$(eval_gettext "A git directory for '\$sm_name' is found locally with remote(s):")"
244                                 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^,"  ", -e s,' (fetch)',, >&2
245                                 echo >&2 "$(eval_gettext "If you want to reuse this local git directory instead of cloning again from")"
246                                 echo >&2 "  $realrepo"
247                                 echo >&2 "$(eval_gettext "use the '--force' option. If the local git directory is not the correct repo")"
248                                 die "$(eval_gettext "or you are unsure what this means choose another name with the '--name' option.")"
249                         else
250                                 echo "$(eval_gettext "Reactivating local git directory for submodule '\$sm_name'.")"
251                         fi
252                 fi
253                 git submodule--helper clone ${GIT_QUIET:+--quiet} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" ${reference:+"$reference"} ${depth:+"$depth"} || exit
254                 (
255                         sanitize_submodule_env
256                         cd "$sm_path" &&
257                         # ash fails to wordsplit ${branch:+-b "$branch"...}
258                         case "$branch" in
259                         '') git checkout -f -q ;;
260                         ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
261                         esac
262                 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
263         fi
264         git config submodule."$sm_name".url "$realrepo"
265
266         git add $force "$sm_path" ||
267         die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
268
269         git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
270         git config -f .gitmodules submodule."$sm_name".url "$repo" &&
271         if test -n "$branch"
272         then
273                 git config -f .gitmodules submodule."$sm_name".branch "$branch"
274         fi &&
275         git add --force .gitmodules ||
276         die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
277 }
278
279 #
280 # Execute an arbitrary command sequence in each checked out
281 # submodule
282 #
283 # $@ = command to execute
284 #
285 cmd_foreach()
286 {
287         # parse $args after "submodule ... foreach".
288         while test $# -ne 0
289         do
290                 case "$1" in
291                 -q|--quiet)
292                         GIT_QUIET=1
293                         ;;
294                 --recursive)
295                         recursive=1
296                         ;;
297                 -*)
298                         usage
299                         ;;
300                 *)
301                         break
302                         ;;
303                 esac
304                 shift
305         done
306
307         toplevel=$(pwd)
308
309         # dup stdin so that it can be restored when running the external
310         # command in the subshell (and a recursive call to this function)
311         exec 3<&0
312
313         {
314                 git submodule--helper list --prefix "$wt_prefix" ||
315                 echo "#unmatched"
316         } |
317         while read mode sha1 stage sm_path
318         do
319                 die_if_unmatched "$mode"
320                 if test -e "$sm_path"/.git
321                 then
322                         displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
323                         say "$(eval_gettext "Entering '\$displaypath'")"
324                         name=$(git submodule--helper name "$sm_path")
325                         (
326                                 prefix="$prefix$sm_path/"
327                                 sanitize_submodule_env
328                                 cd "$sm_path" &&
329                                 sm_path=$(git submodule--helper relative-path "$sm_path" "$wt_prefix") &&
330                                 # we make $path available to scripts ...
331                                 path=$sm_path &&
332                                 if test $# -eq 1
333                                 then
334                                         eval "$1"
335                                 else
336                                         "$@"
337                                 fi &&
338                                 if test -n "$recursive"
339                                 then
340                                         cmd_foreach "--recursive" "$@"
341                                 fi
342                         ) <&3 3<&- ||
343                         die "$(eval_gettext "Stopping at '\$displaypath'; script returned non-zero status.")"
344                 fi
345         done
346 }
347
348 #
349 # Register submodules in .git/config
350 #
351 # $@ = requested paths (default to all)
352 #
353 cmd_init()
354 {
355         # parse $args after "submodule ... init".
356         while test $# -ne 0
357         do
358                 case "$1" in
359                 -q|--quiet)
360                         GIT_QUIET=1
361                         ;;
362                 --)
363                         shift
364                         break
365                         ;;
366                 -*)
367                         usage
368                         ;;
369                 *)
370                         break
371                         ;;
372                 esac
373                 shift
374         done
375
376         git ${wt_prefix:+-C "$wt_prefix"} submodule--helper init ${GIT_QUIET:+--quiet} ${prefix:+--prefix "$prefix"} "$@"
377 }
378
379 #
380 # Unregister submodules from .git/config and remove their work tree
381 #
382 # $@ = requested paths (use '.' to deinit all submodules)
383 #
384 cmd_deinit()
385 {
386         # parse $args after "submodule ... deinit".
387         deinit_all=
388         while test $# -ne 0
389         do
390                 case "$1" in
391                 -f|--force)
392                         force=$1
393                         ;;
394                 -q|--quiet)
395                         GIT_QUIET=1
396                         ;;
397                 --all)
398                         deinit_all=t
399                         ;;
400                 --)
401                         shift
402                         break
403                         ;;
404                 -*)
405                         usage
406                         ;;
407                 *)
408                         break
409                         ;;
410                 esac
411                 shift
412         done
413
414         if test -n "$deinit_all" && test "$#" -ne 0
415         then
416                 echo >&2 "$(eval_gettext "pathspec and --all are incompatible")"
417                 usage
418         fi
419         if test $# = 0 && test -z "$deinit_all"
420         then
421                 die "$(eval_gettext "Use '--all' if you really want to deinitialize all submodules")"
422         fi
423
424         {
425                 git submodule--helper list --prefix "$wt_prefix" "$@" ||
426                 echo "#unmatched"
427         } |
428         while read mode sha1 stage sm_path
429         do
430                 die_if_unmatched "$mode"
431                 name=$(git submodule--helper name "$sm_path") || exit
432
433                 displaypath=$(git submodule--helper relative-path "$sm_path" "$wt_prefix")
434
435                 # Remove the submodule work tree (unless the user already did it)
436                 if test -d "$sm_path"
437                 then
438                         # Protect submodules containing a .git directory
439                         if test -d "$sm_path/.git"
440                         then
441                                 echo >&2 "$(eval_gettext "Submodule work tree '\$displaypath' contains a .git directory")"
442                                 die "$(eval_gettext "(use 'rm -rf' if you really want to remove it including all of its history)")"
443                         fi
444
445                         if test -z "$force"
446                         then
447                                 git rm -qn "$sm_path" ||
448                                 die "$(eval_gettext "Submodule work tree '\$displaypath' contains local modifications; use '-f' to discard them")"
449                         fi
450                         rm -rf "$sm_path" &&
451                         say "$(eval_gettext "Cleared directory '\$displaypath'")" ||
452                         say "$(eval_gettext "Could not remove submodule work tree '\$displaypath'")"
453                 fi
454
455                 mkdir "$sm_path" || say "$(eval_gettext "Could not create empty submodule directory '\$displaypath'")"
456
457                 # Remove the .git/config entries (unless the user already did it)
458                 if test -n "$(git config --get-regexp submodule."$name\.")"
459                 then
460                         # Remove the whole section so we have a clean state when
461                         # the user later decides to init this submodule again
462                         url=$(git config submodule."$name".url)
463                         git config --remove-section submodule."$name" 2>/dev/null &&
464                         say "$(eval_gettext "Submodule '\$name' (\$url) unregistered for path '\$displaypath'")"
465                 fi
466         done
467 }
468
469 is_tip_reachable () (
470         sanitize_submodule_env &&
471         cd "$1" &&
472         rev=$(git rev-list -n 1 "$2" --not --all 2>/dev/null) &&
473         test -z "$rev"
474 )
475
476 fetch_in_submodule () (
477         sanitize_submodule_env &&
478         cd "$1" &&
479         case "$2" in
480         '')
481                 git fetch ;;
482         *)
483                 git fetch $(get_default_remote) "$2" ;;
484         esac
485 )
486
487 #
488 # Update each submodule path to correct revision, using clone and checkout as needed
489 #
490 # $@ = requested paths (default to all)
491 #
492 cmd_update()
493 {
494         # parse $args after "submodule ... update".
495         while test $# -ne 0
496         do
497                 case "$1" in
498                 -q|--quiet)
499                         GIT_QUIET=1
500                         ;;
501                 -i|--init)
502                         init=1
503                         ;;
504                 --remote)
505                         remote=1
506                         ;;
507                 -N|--no-fetch)
508                         nofetch=1
509                         ;;
510                 -f|--force)
511                         force=$1
512                         ;;
513                 -r|--rebase)
514                         update="rebase"
515                         ;;
516                 --reference)
517                         case "$2" in '') usage ;; esac
518                         reference="--reference=$2"
519                         shift
520                         ;;
521                 --reference=*)
522                         reference="$1"
523                         ;;
524                 -m|--merge)
525                         update="merge"
526                         ;;
527                 --recursive)
528                         recursive=1
529                         ;;
530                 --checkout)
531                         update="checkout"
532                         ;;
533                 --depth)
534                         case "$2" in '') usage ;; esac
535                         depth="--depth=$2"
536                         shift
537                         ;;
538                 --depth=*)
539                         depth=$1
540                         ;;
541                 -j|--jobs)
542                         case "$2" in '') usage ;; esac
543                         jobs="--jobs=$2"
544                         shift
545                         ;;
546                 --jobs=*)
547                         jobs=$1
548                         ;;
549                 --)
550                         shift
551                         break
552                         ;;
553                 -*)
554                         usage
555                         ;;
556                 *)
557                         break
558                         ;;
559                 esac
560                 shift
561         done
562
563         if test -n "$init"
564         then
565                 cmd_init "--" "$@" || return
566         fi
567
568         {
569         git submodule--helper update-clone ${GIT_QUIET:+--quiet} \
570                 ${wt_prefix:+--prefix "$wt_prefix"} \
571                 ${prefix:+--recursive-prefix "$prefix"} \
572                 ${update:+--update "$update"} \
573                 ${reference:+--reference "$reference"} \
574                 ${depth:+--depth "$depth"} \
575                 ${jobs:+$jobs} \
576                 "$@" || echo "#unmatched"
577         } | {
578         err=
579         while read mode sha1 stage just_cloned sm_path
580         do
581                 die_if_unmatched "$mode"
582
583                 name=$(git submodule--helper name "$sm_path") || exit
584                 url=$(git config submodule."$name".url)
585                 branch=$(get_submodule_config "$name" branch master)
586                 if ! test -z "$update"
587                 then
588                         update_module=$update
589                 else
590                         update_module=$(git config submodule."$name".update)
591                         if test -z "$update_module"
592                         then
593                                 update_module="checkout"
594                         fi
595                 fi
596
597                 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
598
599                 if test $just_cloned -eq 1
600                 then
601                         subsha1=
602                         update_module=checkout
603                 else
604                         subsha1=$(sanitize_submodule_env; cd "$sm_path" &&
605                                 git rev-parse --verify HEAD) ||
606                         die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
607                 fi
608
609                 if test -n "$remote"
610                 then
611                         if test -z "$nofetch"
612                         then
613                                 # Fetch remote before determining tracking $sha1
614                                 (sanitize_submodule_env; cd "$sm_path" && git-fetch) ||
615                                 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
616                         fi
617                         remote_name=$(sanitize_submodule_env; cd "$sm_path" && get_default_remote)
618                         sha1=$(sanitize_submodule_env; cd "$sm_path" &&
619                                 git rev-parse --verify "${remote_name}/${branch}") ||
620                         die "$(eval_gettext "Unable to find current ${remote_name}/${branch} revision in submodule path '\$sm_path'")"
621                 fi
622
623                 if test "$subsha1" != "$sha1" || test -n "$force"
624                 then
625                         subforce=$force
626                         # If we don't already have a -f flag and the submodule has never been checked out
627                         if test -z "$subsha1" && test -z "$force"
628                         then
629                                 subforce="-f"
630                         fi
631
632                         if test -z "$nofetch"
633                         then
634                                 # Run fetch only if $sha1 isn't present or it
635                                 # is not reachable from a ref.
636                                 is_tip_reachable "$sm_path" "$sha1" ||
637                                 fetch_in_submodule "$sm_path" ||
638                                 die "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
639
640                                 # Now we tried the usual fetch, but $sha1 may
641                                 # not be reachable from any of the refs
642                                 is_tip_reachable "$sm_path" "$sha1" ||
643                                 fetch_in_submodule "$sm_path" "$sha1" ||
644                                 die "$(eval_gettext "Fetched in submodule path '\$displaypath', but it did not contain $sha1. Direct fetching of that commit failed.")"
645                         fi
646
647                         must_die_on_failure=
648                         case "$update_module" in
649                         checkout)
650                                 command="git checkout $subforce -q"
651                                 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
652                                 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
653                                 ;;
654                         rebase)
655                                 command="git rebase"
656                                 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
657                                 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
658                                 must_die_on_failure=yes
659                                 ;;
660                         merge)
661                                 command="git merge"
662                                 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
663                                 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
664                                 must_die_on_failure=yes
665                                 ;;
666                         !*)
667                                 command="${update_module#!}"
668                                 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$displaypath'")"
669                                 say_msg="$(eval_gettext "Submodule path '\$displaypath': '\$command \$sha1'")"
670                                 must_die_on_failure=yes
671                                 ;;
672                         *)
673                                 die "$(eval_gettext "Invalid update mode '$update_module' for submodule '$name'")"
674                         esac
675
676                         if (sanitize_submodule_env; cd "$sm_path" && $command "$sha1")
677                         then
678                                 say "$say_msg"
679                         elif test -n "$must_die_on_failure"
680                         then
681                                 die_with_status 2 "$die_msg"
682                         else
683                                 err="${err};$die_msg"
684                                 continue
685                         fi
686                 fi
687
688                 if test -n "$recursive"
689                 then
690                         (
691                                 prefix=$(git submodule--helper relative-path "$prefix$sm_path/" "$wt_prefix")
692                                 wt_prefix=
693                                 sanitize_submodule_env
694                                 cd "$sm_path" &&
695                                 eval cmd_update
696                         )
697                         res=$?
698                         if test $res -gt 0
699                         then
700                                 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
701                                 if test $res -eq 1
702                                 then
703                                         err="${err};$die_msg"
704                                         continue
705                                 else
706                                         die_with_status $res "$die_msg"
707                                 fi
708                         fi
709                 fi
710         done
711
712         if test -n "$err"
713         then
714                 OIFS=$IFS
715                 IFS=';'
716                 for e in $err
717                 do
718                         if test -n "$e"
719                         then
720                                 echo >&2 "$e"
721                         fi
722                 done
723                 IFS=$OIFS
724                 exit 1
725         fi
726         }
727 }
728
729 set_name_rev () {
730         revname=$( (
731                 sanitize_submodule_env
732                 cd "$1" && {
733                         git describe "$2" 2>/dev/null ||
734                         git describe --tags "$2" 2>/dev/null ||
735                         git describe --contains "$2" 2>/dev/null ||
736                         git describe --all --always "$2"
737                 }
738         ) )
739         test -z "$revname" || revname=" ($revname)"
740 }
741 #
742 # Show commit summary for submodules in index or working tree
743 #
744 # If '--cached' is given, show summary between index and given commit,
745 # or between working tree and given commit
746 #
747 # $@ = [commit (default 'HEAD'),] requested paths (default all)
748 #
749 cmd_summary() {
750         summary_limit=-1
751         for_status=
752         diff_cmd=diff-index
753
754         # parse $args after "submodule ... summary".
755         while test $# -ne 0
756         do
757                 case "$1" in
758                 --cached)
759                         cached="$1"
760                         ;;
761                 --files)
762                         files="$1"
763                         ;;
764                 --for-status)
765                         for_status="$1"
766                         ;;
767                 -n|--summary-limit)
768                         summary_limit="$2"
769                         isnumber "$summary_limit" || usage
770                         shift
771                         ;;
772                 --summary-limit=*)
773                         summary_limit="${1#--summary-limit=}"
774                         isnumber "$summary_limit" || usage
775                         ;;
776                 --)
777                         shift
778                         break
779                         ;;
780                 -*)
781                         usage
782                         ;;
783                 *)
784                         break
785                         ;;
786                 esac
787                 shift
788         done
789
790         test $summary_limit = 0 && return
791
792         if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
793         then
794                 head=$rev
795                 test $# = 0 || shift
796         elif test -z "$1" || test "$1" = "HEAD"
797         then
798                 # before the first commit: compare with an empty tree
799                 head=$(git hash-object -w -t tree --stdin </dev/null)
800                 test -z "$1" || shift
801         else
802                 head="HEAD"
803         fi
804
805         if [ -n "$files" ]
806         then
807                 test -n "$cached" &&
808                 die "$(gettext "The --cached option cannot be used with the --files option")"
809                 diff_cmd=diff-files
810                 head=
811         fi
812
813         cd_to_toplevel
814         eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
815         # Get modified modules cared by user
816         modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
817                 sane_egrep '^:([0-7]* )?160000' |
818                 while read mod_src mod_dst sha1_src sha1_dst status sm_path
819                 do
820                         # Always show modules deleted or type-changed (blob<->module)
821                         if test "$status" = D || test "$status" = T
822                         then
823                                 printf '%s\n' "$sm_path"
824                                 continue
825                         fi
826                         # Respect the ignore setting for --for-status.
827                         if test -n "$for_status"
828                         then
829                                 name=$(git submodule--helper name "$sm_path")
830                                 ignore_config=$(get_submodule_config "$name" ignore none)
831                                 test $status != A && test $ignore_config = all && continue
832                         fi
833                         # Also show added or modified modules which are checked out
834                         GIT_DIR="$sm_path/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
835                         printf '%s\n' "$sm_path"
836                 done
837         )
838
839         test -z "$modules" && return
840
841         git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
842         sane_egrep '^:([0-7]* )?160000' |
843         cut -c2- |
844         while read mod_src mod_dst sha1_src sha1_dst status name
845         do
846                 if test -z "$cached" &&
847                         test $sha1_dst = 0000000000000000000000000000000000000000
848                 then
849                         case "$mod_dst" in
850                         160000)
851                                 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
852                                 ;;
853                         100644 | 100755 | 120000)
854                                 sha1_dst=$(git hash-object $name)
855                                 ;;
856                         000000)
857                                 ;; # removed
858                         *)
859                                 # unexpected type
860                                 eval_gettextln "unexpected mode \$mod_dst" >&2
861                                 continue ;;
862                         esac
863                 fi
864                 missing_src=
865                 missing_dst=
866
867                 test $mod_src = 160000 &&
868                 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
869                 missing_src=t
870
871                 test $mod_dst = 160000 &&
872                 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
873                 missing_dst=t
874
875                 display_name=$(git submodule--helper relative-path "$name" "$wt_prefix")
876
877                 total_commits=
878                 case "$missing_src,$missing_dst" in
879                 t,)
880                         errmsg="$(eval_gettext "  Warn: \$display_name doesn't contain commit \$sha1_src")"
881                         ;;
882                 ,t)
883                         errmsg="$(eval_gettext "  Warn: \$display_name doesn't contain commit \$sha1_dst")"
884                         ;;
885                 t,t)
886                         errmsg="$(eval_gettext "  Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
887                         ;;
888                 *)
889                         errmsg=
890                         total_commits=$(
891                         if test $mod_src = 160000 && test $mod_dst = 160000
892                         then
893                                 range="$sha1_src...$sha1_dst"
894                         elif test $mod_src = 160000
895                         then
896                                 range=$sha1_src
897                         else
898                                 range=$sha1_dst
899                         fi
900                         GIT_DIR="$name/.git" \
901                         git rev-list --first-parent $range -- | wc -l
902                         )
903                         total_commits=" ($(($total_commits + 0)))"
904                         ;;
905                 esac
906
907                 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
908                 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
909                 if test $status = T
910                 then
911                         blob="$(gettext "blob")"
912                         submodule="$(gettext "submodule")"
913                         if test $mod_dst = 160000
914                         then
915                                 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
916                         else
917                                 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
918                         fi
919                 else
920                         echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
921                 fi
922                 if test -n "$errmsg"
923                 then
924                         # Don't give error msg for modification whose dst is not submodule
925                         # i.e. deleted or changed to blob
926                         test $mod_dst = 160000 && echo "$errmsg"
927                 else
928                         if test $mod_src = 160000 && test $mod_dst = 160000
929                         then
930                                 limit=
931                                 test $summary_limit -gt 0 && limit="-$summary_limit"
932                                 GIT_DIR="$name/.git" \
933                                 git log $limit --pretty='format:  %m %s' \
934                                 --first-parent $sha1_src...$sha1_dst
935                         elif test $mod_dst = 160000
936                         then
937                                 GIT_DIR="$name/.git" \
938                                 git log --pretty='format:  > %s' -1 $sha1_dst
939                         else
940                                 GIT_DIR="$name/.git" \
941                                 git log --pretty='format:  < %s' -1 $sha1_src
942                         fi
943                         echo
944                 fi
945                 echo
946         done
947 }
948 #
949 # List all submodules, prefixed with:
950 #  - submodule not initialized
951 #  + different revision checked out
952 #
953 # If --cached was specified the revision in the index will be printed
954 # instead of the currently checked out revision.
955 #
956 # $@ = requested paths (default to all)
957 #
958 cmd_status()
959 {
960         # parse $args after "submodule ... status".
961         while test $# -ne 0
962         do
963                 case "$1" in
964                 -q|--quiet)
965                         GIT_QUIET=1
966                         ;;
967                 --cached)
968                         cached=1
969                         ;;
970                 --recursive)
971                         recursive=1
972                         ;;
973                 --)
974                         shift
975                         break
976                         ;;
977                 -*)
978                         usage
979                         ;;
980                 *)
981                         break
982                         ;;
983                 esac
984                 shift
985         done
986
987         {
988                 git submodule--helper list --prefix "$wt_prefix" "$@" ||
989                 echo "#unmatched"
990         } |
991         while read mode sha1 stage sm_path
992         do
993                 die_if_unmatched "$mode"
994                 name=$(git submodule--helper name "$sm_path") || exit
995                 url=$(git config submodule."$name".url)
996                 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
997                 if test "$stage" = U
998                 then
999                         say "U$sha1 $displaypath"
1000                         continue
1001                 fi
1002                 if test -z "$url" ||
1003                 {
1004                         ! test -d "$sm_path"/.git &&
1005                         ! test -f "$sm_path"/.git
1006                 }
1007                 then
1008                         say "-$sha1 $displaypath"
1009                         continue;
1010                 fi
1011                 if git diff-files --ignore-submodules=dirty --quiet -- "$sm_path"
1012                 then
1013                         set_name_rev "$sm_path" "$sha1"
1014                         say " $sha1 $displaypath$revname"
1015                 else
1016                         if test -z "$cached"
1017                         then
1018                                 sha1=$(sanitize_submodule_env; cd "$sm_path" && git rev-parse --verify HEAD)
1019                         fi
1020                         set_name_rev "$sm_path" "$sha1"
1021                         say "+$sha1 $displaypath$revname"
1022                 fi
1023
1024                 if test -n "$recursive"
1025                 then
1026                         (
1027                                 prefix="$displaypath/"
1028                                 sanitize_submodule_env
1029                                 wt_prefix=
1030                                 cd "$sm_path" &&
1031                                 eval cmd_status
1032                         ) ||
1033                         die "$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
1034                 fi
1035         done
1036 }
1037 #
1038 # Sync remote urls for submodules
1039 # This makes the value for remote.$remote.url match the value
1040 # specified in .gitmodules.
1041 #
1042 cmd_sync()
1043 {
1044         while test $# -ne 0
1045         do
1046                 case "$1" in
1047                 -q|--quiet)
1048                         GIT_QUIET=1
1049                         shift
1050                         ;;
1051                 --recursive)
1052                         recursive=1
1053                         shift
1054                         ;;
1055                 --)
1056                         shift
1057                         break
1058                         ;;
1059                 -*)
1060                         usage
1061                         ;;
1062                 *)
1063                         break
1064                         ;;
1065                 esac
1066         done
1067         cd_to_toplevel
1068         {
1069                 git submodule--helper list --prefix "$wt_prefix" "$@" ||
1070                 echo "#unmatched"
1071         } |
1072         while read mode sha1 stage sm_path
1073         do
1074                 die_if_unmatched "$mode"
1075                 name=$(git submodule--helper name "$sm_path")
1076                 url=$(git config -f .gitmodules --get submodule."$name".url)
1077
1078                 # Possibly a url relative to parent
1079                 case "$url" in
1080                 ./*|../*)
1081                         # rewrite foo/bar as ../.. to find path from
1082                         # submodule work tree to superproject work tree
1083                         up_path="$(printf '%s\n' "$sm_path" | sed "s/[^/][^/]*/../g")" &&
1084                         # guarantee a trailing /
1085                         up_path=${up_path%/}/ &&
1086                         # path from submodule work tree to submodule origin repo
1087                         sub_origin_url=$(git submodule--helper resolve-relative-url "$url" "$up_path") &&
1088                         # path from superproject work tree to submodule origin repo
1089                         super_config_url=$(git submodule--helper resolve-relative-url "$url") || exit
1090                         ;;
1091                 *)
1092                         sub_origin_url="$url"
1093                         super_config_url="$url"
1094                         ;;
1095                 esac
1096
1097                 if git config "submodule.$name.url" >/dev/null 2>/dev/null
1098                 then
1099                         displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
1100                         say "$(eval_gettext "Synchronizing submodule url for '\$displaypath'")"
1101                         git config submodule."$name".url "$super_config_url"
1102
1103                         if test -e "$sm_path"/.git
1104                         then
1105                         (
1106                                 sanitize_submodule_env
1107                                 cd "$sm_path"
1108                                 remote=$(get_default_remote)
1109                                 git config remote."$remote".url "$sub_origin_url"
1110
1111                                 if test -n "$recursive"
1112                                 then
1113                                         prefix="$prefix$sm_path/"
1114                                         eval cmd_sync
1115                                 fi
1116                         )
1117                         fi
1118                 fi
1119         done
1120 }
1121
1122 # This loop parses the command line arguments to find the
1123 # subcommand name to dispatch.  Parsing of the subcommand specific
1124 # options are primarily done by the subcommand implementations.
1125 # Subcommand specific options such as --branch and --cached are
1126 # parsed here as well, for backward compatibility.
1127
1128 while test $# != 0 && test -z "$command"
1129 do
1130         case "$1" in
1131         add | foreach | init | deinit | update | status | summary | sync)
1132                 command=$1
1133                 ;;
1134         -q|--quiet)
1135                 GIT_QUIET=1
1136                 ;;
1137         -b|--branch)
1138                 case "$2" in
1139                 '')
1140                         usage
1141                         ;;
1142                 esac
1143                 branch="$2"; shift
1144                 ;;
1145         --cached)
1146                 cached="$1"
1147                 ;;
1148         --)
1149                 break
1150                 ;;
1151         -*)
1152                 usage
1153                 ;;
1154         *)
1155                 break
1156                 ;;
1157         esac
1158         shift
1159 done
1160
1161 # No command word defaults to "status"
1162 if test -z "$command"
1163 then
1164     if test $# = 0
1165     then
1166         command=status
1167     else
1168         usage
1169     fi
1170 fi
1171
1172 # "-b branch" is accepted only by "add"
1173 if test -n "$branch" && test "$command" != add
1174 then
1175         usage
1176 fi
1177
1178 # "--cached" is accepted only by "status" and "summary"
1179 if test -n "$cached" && test "$command" != status && test "$command" != summary
1180 then
1181         usage
1182 fi
1183
1184 "cmd_$command" "$@"